---

- name: reset local_application_checksum
  set_fact:
    local_application_checksum: ""
  when: local_application_checksum is defined

- name: reset application_checksum
  set_fact:
    application_checksum: ""
  when: application_checksum is defined

- name: reset archive url
  set_fact:
    artefact_url: ""
  when: artefact_url is defined

- name: reset archive name
  set_fact:
    artefact_name: ""
  when: artefact_name is defined

- name: reset archive checksum
  set_fact:
    artefact_checksum: ""
  when: artefact_checksum is defined

- name: do facts module to get latest information
  setup:
    gather_subset:
      - '!all'
      - '!any'
      - facter

# ---------------------------------------------------------------------------------------------

- name: set local application data
  set_fact:
    _local_application_data: "{{ ansible_local[ coremedia_application_name ] }}"
  when: ansible_local[ coremedia_application_name ] is defined

- name: set local application checksum
  set_fact:
    local_application_checksum: "{{ _local_application_data.checksum }}"
  when: _local_application_data is defined and _local_application_data.checksum is defined

# ---------------------------------------------------------------------------------------------

- name: detect application deployment data
  set_fact:
    _application_data: "{{ coremedia_applications[ coremedia_application_name ] }}"
  when: coremedia_applications is defined and coremedia_applications | count != 0

- name: set archive url
  set_fact:
    artefact_url: "{{ _application_data.artefact_url }}"
  when: _application_data is defined and _application_data.artefact_url is defined

- name: set archive name
  set_fact:
    artefact_name: "{{ _application_data.artefact_name }}"
  when: _application_data is defined and _application_data.artefact_name is defined

- name: set archive checksum
  set_fact:
    artefact_checksum: "{{ _application_data.artefact_checksum }}"
  when: _application_data is defined and _application_data.artefact_checksum is defined

- name: assert missing archive name and/or checksum
  assert:
    that:
      - artefact_name | length != 0
      - artefact_checksum | length != 0
    msg: "application archive name or checksum is missing"
    quiet: true

# ---------------------------------------------------------------------------------------------

- name: detect if download needed
  set_fact:
    artefact_download_needed: true
  when: (
    local_application_checksum | length == 0 or
    (local_application_checksum != artefact_checksum) )
